<?php
	abstract class __search extends baseModuleAdmin {
		public function config() {
			$this->redirect($this->pre_lang . "/admin/search/index_control/");
		}


		public function index_control() {
			$regedit = regedit::getInstance();
			$searchModel = searchModel::getInstance();
			
			$params = array(
				"info" => array(
					"status:index_pages"		=> NULL,
					"status:index_words"		=> NULL,
					"status:index_words_uniq"		=> NULL,
					"status:index_last"		=> NULL
				),
				"globals" => array(
					"int:per_page"		=> NULL
				)
			);

			$mode = getRequest("param0");
			if($mode == "do") {
				$params = $this->expectParams($params);
				$regedit->setVal("//modules/search/per_page", $params['globals']['int:per_page']);
				$this->chooseRedirect();
			}


			$params['info']['status:index_pages'] = $searchModel->getIndexPages();
			$params['info']['status:index_words'] = $searchModel->getIndexWords();
			$params['info']['status:index_words_uniq'] = $searchModel->getIndexWordsUniq();
			$params['info']['status:index_last'] = ($index_last = $searchModel->getIndexLast()) ? date("Y-m-d H:i:s", $index_last) : "-";
			$params['globals']['int:per_page'] = $regedit->getVal("//modules/search/per_page");


			$this->setDataType("settings");
			$this->setActionType("modify");

			$data = $this->prepareData($params, "settings");

			$this->setData($data);
			return $this->doData();
		}


		public function truncate() {
			searchModel::getInstance()->truncate_index();
			$this->redirect($this->pre_lang . "/admin/search/");
		}


		public function reindex() {
			searchModel::getInstance()->index_all();
			$this->redirect($this->pre_lang . "/admin/search/");
		}
		
		public function partialReindex() {
			$this->setDataType("settings");
			$this->setActionType("view");

			$search = searchModel::getInstance();
			$current = (int) $search->index_all(3);
			$total = (int) $search->getAllIndexablePages();
			
			$data = Array(
				'index-status' => Array(
					'attribute:current' => $current,
					'attribute:total' => $total
				)
			);

			$this->setData($data);
			return $this->doData();
		}
	};
?>
